#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct bt_node
{
 void *data;
 struct bt_node *parent;
 struct bt_node *left;
 struct bt_node *right;
};

struct bt_node bt_tree;

int (*cmp)(void* , void*);
int b_cmp(int *A,int *B);
struct bt_node *bt_new(int *t_cmp);
struct bt_node *bt_find(struct bt_node *tree, void *key);
void bt_insert(struct bt_node *tree, void *key);
void bt_remove(struct bt_node *tree, void *key);
void bt_replace(struct bt_node *tree, void *key1, void *key2);
void bt_replace(struct bt_node *tree, void *key1, void *key2);
void bt_go(struct bt_node *tree);

////////////////////////////////MAIN//////////////////////////////
int main(int argc,char *argv[])
{
	return 0;
};
////////////////////////////////MAIN//////////////////////////////


int b_cmp(int *A,int *B)
{
	if (*A > *B) return 1;
	else if (*A < *B) return -1;
	else return 0;
};


struct bt_node *bt_new(int *t_cmp)
{
	cmp = t_cmp;

	struct bt_node *x = malloc(sizeof(struct bt_node));

	(*x).data = NULL;
	(*x).parent = NULL;
	(*x).left = NULL;
	(*x).right = NULL;

	return x;
};

struct bt_node *bt_find(struct bt_node *tree, void *key)
{
	if (!((*tree).data)) return NULL;

	if ( (*cmp)(key,(*tree).data) == -1 ) return bt_find( (*tree).left, key);
	return bt_find( (*tree).right, key);
};

void bt_insert(struct bt_node *tree, void *key)
{
	if (!((*tree).data))
		{
			(*tree).data = key;

			struct bt_node *l,*r;

			l = malloc(sizeof(struct bt_node));
			r = malloc(sizeof(struct bt_node));

			(*l).data = NULL;
			(*l).parent = tree;
			(*r).data = NULL;
			(*r).parent = tree;

			(*tree).left = l;
			(*tree).right = r;

			return;
		}

	if ( (*cmp)(key,(*tree).data) == -1 ) bt_insert( (*tree).left, key);
	else bt_insert( (*tree).right, key);
};

void bt_remove(struct bt_node *tree, void *key)
{
	if (!((*tree).data)) return;

	if ( (*cmp)(key,(*tree).data) == -1 )
		{
			bt_remove( (*tree).left, key);
			return;
		}
	else if ( (*cmp)(key,(*tree).data) == 1 )
		{
			bt_remove( (*tree).right, key);
			return;
		};

	if ( ((*(*tree).right).data = NULL) && ((*(*tree).left).data = NULL) )
		{
			free( (*tree).right );
			free( (*tree).left );
			(*tree).data = NULL;
			return;
		};

	struct bt_node *p;

	if ( ((*(*tree).right).data = NULL) || ((*(*tree).left).data = NULL) )
		{

			if ((*(*tree).right).data = NULL)
				{
					p = (*tree).left;
					tree = (*tree).left;

					free( p );
				}
			else
				{
					p = (*tree).right;
					tree = (*tree).right;

					free( p );
				}

			return;
		};

	p = (*tree).right;

	while ( (*p).data != NULL )
		{
			p = (*p).left;
		};

	p = (*p).parent;

	(*tree).data = (*p).data;

	free( (*p).left );
	free( (*p).right );
	(*p).left = NULL;
	(*p).right = NULL;
	(*p).data = NULL;

};

void bt_replace(struct bt_node *tree, void *key1, void *key2)
{
	bt_remove(tree, key1);
	bt_insert(tree, key2);
};

void bt_go(struct bt_node *tree)
{
	bt_go((*tree).left);
	bt_go((*tree).right);
};